/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.64
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.54 2009/12/06 09:34:36 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.64 2010/02/15 16:34:00 spatz Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Ben de Groot <yngwin@gentoo.org>,
8# Markos Chandras <hwoarang@gentoo.org>, 8# Markos Chandras <hwoarang@gentoo.org>,
12# @DESCRIPTION: 12# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 13# This eclass contains various functions that are used when building Qt4
14 14
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 15inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 16
17IUSE="${IUSE} debug pch" 17MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV}
20else
21 MY_P=qt-x11-opensource-src-${MY_PV}
22fi
23
24HOMEPAGE="http://qt.nokia.com/"
25SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
26
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28IUSE="debug pch aqua"
29
18RDEPEND=" 30RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 31 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 32 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 33 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 34 !>x11-libs/qt-core-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV} 55 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 56 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 57 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 58 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 59"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}"
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 60
59if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}"
61else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi
64S=${WORKDIR}/${MY_P} 61S=${WORKDIR}/${MY_P}
65 62
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 63# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 64# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 65# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH
85qt4-build_pkg_setup() { 66qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 67 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
68
69
70 PATH="${S}/bin${PATH:+:}${PATH}"
71 if [[ ${CHOST} != *-darwin* ]]; then
72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
73 else
74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
75 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
76 # platform detection. Note: needs to come before any directories to
77 # avoid extract failure.
78 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm ${QT4_EXTRACT_DIRECTORIES}"
80 fi
81
82 # Make sure ebuilds use the required EAPI
87 if [[ $EAPI != 2 ]]; then 83 if [[ ${EAPI} != [23] ]]; then
88 # Make sure debug setting corresponds with qt-core (bug 258512) 84 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
89 if [[ $PN != "qt-core" ]]; then 85 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 86 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
91 ~x11-libs/qt-core-${PV} debug" 87 die "qt4-build eclass requires EAPI=2 or EAPI=3"
92 fi 88 fi
93 89
94 # Check USE requirements
95 qt4-build_check_use
96 fi
97
98 PATH="${S}/bin:${PATH}"
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
100
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 90 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 91 ewarn "Using a GCC version lower than 4.1 is not supported!"
103 echo 92 echo
104 ebeep 3 93 ebeep 3
105 fi 94 fi
106
107 if [[ "${P}" == "qt-core-4.6.0_rc1" ]]; then
108 ewarn
109 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
110 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
111 ewarn "re-emerge everything that depends on Qt."
112 ewarn "Use the following command:"
113 ewarn
114 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
115 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
116 ewarn " sed \"s/^/=/\"; done)"
117 ewarn
118 ewarn "YOU'VE BEEN WARNED"
119 ewarn
120 ebeep 3
121 fi
122
123} 95}
124 96
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 97# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 98# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 99# Arguments for build_target_directories. Takes the directories, in which the
135# @FUNCTION: qt4-build_src_unpack 107# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 108# @DESCRIPTION:
137# Unpacks the sources 109# Unpacks the sources
138qt4-build_src_unpack() { 110qt4-build_src_unpack() {
139 setqtenv 111 setqtenv
140 local target targets licenses tar_pkg tar_args 112 local target targets=
141 if version_is_at_least 4.5 ${PV} ; then 113 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
142 licenses="LICENSE.GPL3 LICENSE.LGPL"
143 else
144 licenses="LICENSE.GPL2 LICENSE.GPL3"
145 fi
146 for target in configure ${licenses} projects.pro \
147 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 114 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
148 ${QT4_EXTRACT_DIRECTORIES}; do 115 ${QT4_EXTRACT_DIRECTORIES}; do
149 targets="${targets} ${MY_P}/${target}" 116 targets+=" ${MY_P}/${target}"
150 done 117 done
151 118
152 tar_pkg=${MY_P}.tar.bz2
153 tar_args="xjpf"
154 if version_is_at_least 4.5.3 ${PV} ; then
155 tar_pkg=${tar_pkg/bz2/gz}
156 tar_args="xzpf"
157 fi
158
159 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
160 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
161
162 case "${PV}" in
163 4.4.?)
164 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2 119 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
165 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2 120 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
166 ;;
167 esac
168
169 # Be backwards compatible for now
170 if [[ $EAPI != 2 ]]; then
171 qt4-build_src_prepare
172 fi
173} 121}
174 122
175# @ECLASS-VARIABLE: PATCHES 123# @ECLASS-VARIABLE: PATCHES
176# @DESCRIPTION: 124# @DESCRIPTION:
177# In case you have patches to apply, specify them in PATCHES variable. Make sure 125# In case you have patches to apply, specify them in PATCHES variable. Make sure
187# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 135# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf.
188qt4-build_src_prepare() { 136qt4-build_src_prepare() {
189 setqtenv 137 setqtenv
190 cd "${S}" 138 cd "${S}"
191 139
140 if use aqua; then
141 # provide a proper macx-g++-64
142 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
143
144 sed -e '/^CONFIG/s:app_bundle::' \
145 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
146 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed"
147 fi
148
192 if [[ ${PN} != qt-core ]]; then 149 if [[ ${PN} != qt-core ]]; then
193 skip_qmake_build_patch 150 skip_qmake_build_patch
194 skip_project_generation_patch 151 skip_project_generation_patch
195 symlink_binaries_to_buildtree 152 symlink_binaries_to_buildtree
153 fi
154
155 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
156 # qmake bus errors with -O2 but -O3 works
157 replace-flags -O2 -O3
196 fi 158 fi
197 159
198 # Bug 282984 && Bug 295530 160 # Bug 282984 && Bug 295530
199 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \ 161 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
200 -i configure || die "sed qmake compilers failed" 162 -i configure || die "sed qmake compilers failed"
201 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \ 163 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
202 -i config.tests/unix/compile.test || die "sed test compilers failed" 164 -i config.tests/unix/compile.test || die "sed test compilers failed"
203 165
204 # Bug 178652 166 # Bug 178652
205 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 167 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 168 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207 append-flags -fno-gcse 169 append-flags -fno-gcse
208 fi 170 fi
209 171
210 # Unsupported old gcc versions - hardened needs this :( 172 # Unsupported old gcc versions - hardened needs this :(
211 if [[ $(gcc-major-version) -lt "4" ]] ; then 173 if [[ $(gcc-major-version) -lt 4 ]] ; then
212 ewarn "Appending -fno-stack-protector to CXXFLAGS" 174 ewarn "Appending -fno-stack-protector to CXXFLAGS"
213 append-cxxflags -fno-stack-protector 175 append-cxxflags -fno-stack-protector
214 # Bug 253127 176 # Bug 253127
215 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 177 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
216 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 178 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 189 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 190 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
229 -e "s:X11R6/::" \ 191 -e "s:X11R6/::" \
230 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 192 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
231 193
194 if [[ ${CHOST} != *-darwin* ]]; then
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 195 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 196 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 197 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
235 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 198 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
199 else
200 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
201 # crippled (by design) :/
202 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
203 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
204 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
205 -e "s:-arch\s\w*::g" \
206 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed"
207
208 # Fix configure's -arch settings that appear in qmake/Makefile and also
209 # fix arch handling (automagically duplicates our -arch arg and breaks
210 # pch). Additionally disable Xarch support.
211 sed \
212 -e "s:-arch i386::" \
213 -e "s:-arch ppc::" \
214 -e "s:-arch x86_64::" \
215 -e "s:-arch ppc64::" \
216 -e "s:-arch \$i::" \
217 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
218 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
219 -e "s:-Xarch_x86_64::g" \
220 -e "s:-Xarch_ppc64::g" \
221 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed"
222
223 # On Snow Leopard don't fall back to 10.5 deployment target.
224 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
225 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
226 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
227 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed"
228 fi
229 fi
230
231 # this one is needed for all systems with a separate -liconv, apart from
232 # Darwin, for which the sources already cater for -liconv
233 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
234 sed \
235 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
236 -i config.tests/unix/iconv/iconv.pro \
237 || die "sed on iconv.pro failed"
238 fi
239
240 # we need some patches for Solaris
241 sed -i \
242 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
243 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
244 # use GCC over SunStudio
245 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
246 # don't flirt with non-Prefix stuff, we're quite possessive
247 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
248 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
236 249
237 base_src_prepare 250 base_src_prepare
238} 251}
239 252
240# @FUNCTION: qt4-build_src_configure 253# @FUNCTION: qt4-build_src_configure
242# Default configure phase 255# Default configure phase
243qt4-build_src_configure() { 256qt4-build_src_configure() {
244 setqtenv 257 setqtenv
245 myconf="$(standard_configure_options) ${myconf}" 258 myconf="$(standard_configure_options) ${myconf}"
246 259
260 # this one is needed for all systems with a separate -liconv, apart from
261 # Darwin, for which the sources already cater for -liconv
262 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
263 myconf+=" -liconv"
264
265 if has glib ${IUSE//+} && use glib; then
266 # use -I, -L and -l from configure
267 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
268 # avoid the -pthread argument
269 myconf+=" ${glibflags//-pthread}"
270 unset glibflags
271 fi
272
273 if use aqua ; then
274 # On (snow) leopard use the new (frameworked) cocoa code.
275 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
276 myconf+=" -cocoa -framework"
277
278 # We are crazy and build cocoa + qt3support :-)
279 if use qt3support; then
280 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
281 -i configure
282 fi
283
284 # We need the source's headers, not the installed ones.
285 myconf+=" -I${S}/include"
286
287 # Add hint for the framework location.
288 myconf+=" -F${QTLIBDIR}"
289 fi
290 else
291 # freetype2 include dir is non-standard, thus include it on configure
292 # use -I from configure
293 myconf+=" $(pkg-config --cflags freetype2)"
294 fi
295
247 echo ./configure ${myconf} 296 echo ./configure ${myconf}
248 ./configure ${myconf} || die "./configure failed" 297 ./configure ${myconf} || die "./configure failed"
249 myconf="" 298 myconf=""
250} 299}
251 300
252# @FUNCTION: qt4-build_src_compile 301# @FUNCTION: qt4-build_src_compile
253# @DESCRIPTION: Actual compile phase 302# @DESCRIPTION: Actual compile phase
254qt4-build_src_compile() { 303qt4-build_src_compile() {
255 setqtenv 304 setqtenv
256 # Be backwards compatible for now
257 if [[ $EAPI != 2 ]]; then
258 qt4-build_src_configure
259 fi
260 305
261 build_directories "${QT4_TARGET_DIRECTORIES}" 306 build_directories ${QT4_TARGET_DIRECTORIES}
307}
308
309# @FUNCTION: fix_includes
310# @DESCRIPTION:
311# For MacOSX we need to add some symlinks when frameworks are
312# being used, to avoid complications with some more or less stupid packages.
313fix_includes() {
314 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
315 # Some packages tend to include <Qt/...>
316 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
317
318 # Fake normal headers when frameworks are installed... eases life later on
319 local dest f
320 for frw in "${D}${QTLIBDIR}"/*.framework; do
321 [[ -e "${frw}"/Headers ]] || continue
322 f=$(basename ${frw})
323 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
324 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
325
326 # Link normal headers as well.
327 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
328 h=$(basename ${hdr})
329 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
330 done
331 done
332 fi
262} 333}
263 334
264# @FUNCTION: qt4-build_src_install 335# @FUNCTION: qt4-build_src_install
265# @DESCRIPTION: 336# @DESCRIPTION:
266# Perform the actual installation including some library fixes. 337# Perform the actual installation including some library fixes.
267qt4-build_src_install() { 338qt4-build_src_install() {
339 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
268 setqtenv 340 setqtenv
269 install_directories "${QT4_TARGET_DIRECTORIES}" 341 install_directories ${QT4_TARGET_DIRECTORIES}
270 install_qconfigs 342 install_qconfigs
271 fix_library_files 343 fix_library_files
344 fix_includes
272} 345}
273 346
274# @FUNCTION: setqtenv 347# @FUNCTION: setqtenv
275setqtenv() { 348setqtenv() {
276 # Set up installation directories 349 # Set up installation directories
277 QTBASEDIR=/usr/$(get_libdir)/qt4 350 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
278 QTPREFIXDIR=/usr 351 QTPREFIXDIR=${EPREFIX}/usr
279 QTBINDIR=/usr/bin 352 QTBINDIR=${EPREFIX}/usr/bin
280 QTLIBDIR=/usr/$(get_libdir)/qt4 353 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
281 QMAKE_LIBDIR_QT=${QTLIBDIR} 354 QMAKE_LIBDIR_QT=${QTLIBDIR}
282 QTPCDIR=/usr/$(get_libdir)/pkgconfig 355 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
283 QTDATADIR=/usr/share/qt4 356 QTDATADIR=${EPREFIX}/usr/share/qt4
284 QTDOCDIR=/usr/share/doc/qt-${PV} 357 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
285 QTHEADERDIR=/usr/include/qt4 358 QTHEADERDIR=${EPREFIX}/usr/include/qt4
286 QTPLUGINDIR=${QTLIBDIR}/plugins 359 QTPLUGINDIR=${QTLIBDIR}/plugins
287 QTSYSCONFDIR=/etc/qt4 360 QTSYSCONFDIR=${EPREFIX}/etc/qt4
288 QTTRANSDIR=${QTDATADIR}/translations 361 QTTRANSDIR=${QTDATADIR}/translations
289 QTEXAMPLESDIR=${QTDATADIR}/examples 362 QTEXAMPLESDIR=${QTDATADIR}/examples
290 QTDEMOSDIR=${QTDATADIR}/demos 363 QTDEMOSDIR=${QTDATADIR}/demos
291 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 364 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
292 PLATFORM=$(qt_mkspecs_dir) 365 PLATFORM=$(qt_mkspecs_dir)
293 366
294 unset QMAKESPEC 367 unset QMAKESPEC
295} 368}
296 369
297# @FUNCTION: standard_configure_options 370# @FUNCTION: standard_configure_options
298# @DESCRIPTION: 371# @DESCRIPTION:
299# Sets up some standard configure options, like libdir (if necessary), whether 372# Sets up some standard configure options, like libdir (if necessary), whether
300# debug info is wanted or not. 373# debug info is wanted or not.
301standard_configure_options() { 374standard_configure_options() {
302 local myconf="" 375 local myconf=
303 376
304 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 377 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
305 378
306 # Disable visibility explicitly if gcc version isn't 4 379 # Disable visibility explicitly if gcc version isn't 4
307 if [[ "$(gcc-major-version)" -lt "4" ]]; then 380 if [[ $(gcc-major-version) -lt 4 ]]; then
308 myconf="${myconf} -no-reduce-exports" 381 myconf+=" -no-reduce-exports"
309 fi 382 fi
310 383
311 # precompiled headers doesn't work on hardened, where the flag is masked. 384 # precompiled headers doesn't work on hardened, where the flag is masked.
385 myconf+=" $(qt_use pch)"
386
312 if use pch; then 387 if use debug; then
313 myconf="${myconf} -pch" 388 myconf+=" -debug"
314 else 389 else
315 myconf="${myconf} -no-pch" 390 myconf+=" -release"
316 fi 391 fi
317
318 if use debug; then
319 myconf="${myconf} -debug -no-separate-debug-info" 392 myconf+=" -no-separate-debug-info"
320 else 393
321 myconf="${myconf} -release -no-separate-debug-info" 394 use aqua && myconf+=" -no-framework"
322 fi
323 395
324 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 396 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
325 # $(tc-arch). Therefore we convert it to supported values. 397 # $(tc-arch). Therefore we convert it to supported values.
326 case "$(tc-arch)" in 398 case "$(tc-arch)" in
327 amd64) myconf="${myconf} -arch x86_64" ;; 399 amd64|x64-*) myconf+=" -arch x86_64" ;;
400 ppc-macos) myconf+=" -arch ppc" ;;
328 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 401 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
402 sparc|sparc-*) myconf+=" -arch sparc" ;;
403 x86-macos) myconf+=" -arch x86" ;;
329 x86|x86-*) myconf="${myconf} -arch i386" ;; 404 x86|x86-*) myconf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 405 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
331 hppa|sh) myconf="${myconf} -arch generic" ;; 406 hppa|sh) myconf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 407 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac 408 esac
334 409
335 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 410 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
336 local exceptions= 411 local exceptions=
337 case "${PV}" in 412 case "${PV}" in
338 4.6.*) 413 4.6.*)
339 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then 414 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
415 case "${PV}:${CHOST}" in
416 4.6.0*:*-darwin*)
417 : # http://bugreports.qt.nokia.com/browse/QTBUG-5909
418 # workaround for compilation error on OSX (qt-gui)
419 ;;
420 *)
340 exceptions="-no-exceptions" 421 exceptions="-no-exceptions"
422 ;;
423 esac
341 fi 424 fi
342 ;; 425 ;;
343 *) 426 *)
344 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 427 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
345 ;; 428 ;;
346 esac 429 esac
347 430
431 # note about -reduce-relocations:
432 # That flag seems to introduce major breakage to applications,
433 # mostly to be seen as a core dump with the message "QPixmap: Must
434 # construct a QApplication before a QPaintDevice" on Solaris
435 # -- Daniel Vergien
436 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
437
348 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license 438 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
349 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR} 439 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
350 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} 440 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
351 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR} 441 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
352 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR} 442 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
353 -demosdir ${QTDEMOSDIR} -silent -fast 443 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
354 ${exceptions} 444 ${exceptions}
355 -reduce-relocations -nomake examples -nomake demos" 445 -nomake examples -nomake demos"
356
357 # Make eclass >= 4.5.x ready
358 case "${MY_PV}" in
359 4.5.* | 4.6.* )
360 myconf="${myconf} -opensource"
361 ;;
362 esac
363 446
364 echo "${myconf}" 447 echo "${myconf}"
365} 448}
366 449
367# @FUNCTION: build_directories 450# @FUNCTION: build_directories
368# @USAGE: < directories > 451# @USAGE: < directories >
369# @DESCRIPTION: 452# @DESCRIPTION:
370# Compiles the code in $QT4_TARGET_DIRECTORIES 453# Compiles the code in $QT4_TARGET_DIRECTORIES
371build_directories() { 454build_directories() {
372 local dirs="$@"
373 for x in ${dirs}; do 455 for x in "$@"; do
374 cd "${S}"/${x} 456 pushd "${S}"/${x} >/dev/null
375 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 457 # avoid running over the maximum argument number, bug #299810
458 {
459 echo "${S}"/mkspecs/common/*.conf
460 find "${S}" -name '*.pr[io]'
461 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
376 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 462 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
377 emake CC="@echo compiling \$< && $(tc-getCC)" \ 463 emake CC="@echo compiling \$< && $(tc-getCC)" \
378 CXX="@echo compiling \$< && $(tc-getCXX)" \ 464 CXX="@echo compiling \$< && $(tc-getCXX)" \
379 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 465 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed"
466 popd >/dev/null
380 done 467 done
381} 468}
382 469
383# @FUNCTION: install_directories 470# @FUNCTION: install_directories
384# @USAGE: < directories > 471# @USAGE: < directories >
385# @DESCRIPTION: 472# @DESCRIPTION:
386# run emake install in the given directories, which are separated by spaces 473# run emake install in the given directories, which are separated by spaces
387install_directories() { 474install_directories() {
388 local dirs="$@"
389 for x in ${dirs}; do 475 for x in "$@"; do
390 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 476 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}"
391 emake INSTALL_ROOT="${D}" install || die "emake install failed" 477 emake INSTALL_ROOT="${D}" install || die "emake install failed"
392 popd >/dev/null || die "Can't popd from ${S}/${x}" 478 popd >/dev/null || die "Can't popd from ${S}/${x}"
393 done 479 done
394} 480}
395 481
396# @ECLASS-VARIABLE: QCONFIG_ADD 482# @ECLASS-VARIABLE: QCONFIG_ADD
397# @DESCRIPTION: 483# @DESCRIPTION:
398# List options that need to be added to QT_CONFIG in qconfig.pri 484# List options that need to be added to QT_CONFIG in qconfig.pri
399QCONFIG_ADD="${QCONFIG_ADD:-}" 485: ${QCONFIG_ADD:=}
400 486
401# @ECLASS-VARIABLE: QCONFIG_REMOVE 487# @ECLASS-VARIABLE: QCONFIG_REMOVE
402# @DESCRIPTION: 488# @DESCRIPTION:
403# List options that need to be removed from QT_CONFIG in qconfig.pri 489# List options that need to be removed from QT_CONFIG in qconfig.pri
404QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 490: ${QCONFIG_REMOVE:=}
405 491
406# @ECLASS-VARIABLE: QCONFIG_DEFINE 492# @ECLASS-VARIABLE: QCONFIG_DEFINE
407# @DESCRIPTION: 493# @DESCRIPTION:
408# List variables that should be defined at the top of QtCore/qconfig.h 494# List variables that should be defined at the top of QtCore/qconfig.h
409QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 495: ${QCONFIG_DEFINE:=}
410 496
411# @FUNCTION: install_qconfigs 497# @FUNCTION: install_qconfigs
412# @DESCRIPTION: Install gentoo-specific mkspecs configurations 498# @DESCRIPTION: Install gentoo-specific mkspecs configurations
413install_qconfigs() { 499install_qconfigs() {
414 local x 500 local x
415 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 501 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
416 for x in QCONFIG_ADD QCONFIG_REMOVE; do 502 for x in QCONFIG_ADD QCONFIG_REMOVE; do
417 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 503 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
418 done 504 done
419 insinto ${QTDATADIR}/mkspecs/gentoo 505 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
420 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 506 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
421 fi 507 fi
422 508
423 if [[ -n ${QCONFIG_DEFINE} ]]; then 509 if [[ -n ${QCONFIG_DEFINE} ]]; then
424 for x in ${QCONFIG_DEFINE}; do 510 for x in ${QCONFIG_DEFINE}; do
425 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 511 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
426 done 512 done
427 insinto ${QTHEADERDIR}/Gentoo 513 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
428 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 514 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
429 fi 515 fi
430} 516}
431 517
432# @FUNCTION: generate_qconfigs 518# @FUNCTION: generate_qconfigs
434generate_qconfigs() { 520generate_qconfigs() {
435 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 521 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
436 local x qconfig_add qconfig_remove qconfig_new 522 local x qconfig_add qconfig_remove qconfig_new
437 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 523 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
438 [[ -f ${x} ]] || continue 524 [[ -f ${x} ]] || continue
439 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 525 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
440 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 526 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
441 done 527 done
442 528
443 # these error checks do not use die because dying in pkg_post{inst,rm} 529 # these error checks do not use die because dying in pkg_post{inst,rm}
444 # just makes things worse. 530 # just makes things worse.
445 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 531 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
452 538
453 # generate list of QT_CONFIG entries from the existing list 539 # generate list of QT_CONFIG entries from the existing list
454 # including qconfig_add and excluding qconfig_remove 540 # including qconfig_add and excluding qconfig_remove
455 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 541 for x in $(sed -n 's/^QT_CONFIG +=//p' \
456 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 542 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
457 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 543 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
458 done 544 done
459 545
460 # replace the existing QT_CONFIG list with qconfig_new 546 # replace the existing QT_CONFIG list with qconfig_new
461 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 547 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
462 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 548 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
496# @FUNCTION: qt4-build_pkg_postinst 582# @FUNCTION: qt4-build_pkg_postinst
497# @DESCRIPTION: Generate configuration, plus throws a message about possible 583# @DESCRIPTION: Generate configuration, plus throws a message about possible
498# breakages and proposed solutions. 584# breakages and proposed solutions.
499qt4-build_pkg_postinst() { 585qt4-build_pkg_postinst() {
500 generate_qconfigs 586 generate_qconfigs
501
502 if [[ "${PN}" == "qt-core" ]]; then
503 echo
504 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
505 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
506 ewarn "should recompile the packages providing these plugins. Also, make sure you"
507 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
508 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
509 ewarn
510 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
511 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
512 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
513 ewarn "configuration."
514 ewarn
515 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
516 echo
517 fi
518} 587}
519 588
520# @FUNCTION: skip_qmake_build_patch 589# @FUNCTION: skip_qmake_build_patch
521# @DESCRIPTION: 590# @DESCRIPTION:
522# Don't need to build qmake, as it's already installed from qt-core 591# Don't need to build qmake, as it's already installed from qt-core
558 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 627 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix:
559 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 628 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
560 if [[ -e ${libfile} ]]; then 629 if [[ -e ${libfile} ]]; then
561 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 630 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed"
562 631
563 # Move .pc files into the pkgconfig directory 632 # Move .pc files into the pkgconfig directory
564 dodir ${QTPCDIR} 633 dodir ${QTPCDIR#${EPREFIX}}
565 mv ${libfile} "${D}"/${QTPCDIR}/ \ 634 mv ${libfile} "${D}"/${QTPCDIR}/ \
566 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed." 635 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
567 fi 636 fi
568 done 637 done
569 638
577# This will echo "${enableval}-${feature}" if <flag> is enabled, or 646# This will echo "${enableval}-${feature}" if <flag> is enabled, or
578# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 647# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag>
579# will be used for that. If [enableval] is not specified, it omits the 648# will be used for that. If [enableval] is not specified, it omits the
580# assignment-part 649# assignment-part
581qt_use() { 650qt_use() {
582 local flag="${1}" 651 local flag=$1
583 local feature="${1}" 652 local feature=$1
584 local enableval= 653 local enableval=
585 654
586 [[ -n ${2} ]] && feature=${2} 655 [[ -n $2 ]] && feature=$2
587 [[ -n ${3} ]] && enableval="-${3}" 656 [[ -n $3 ]] && enableval=-$3
588 657
589 if use ${flag}; then 658 if use ${flag}; then
590 echo "${enableval}-${feature}" 659 echo "${enableval}-${feature}"
591 else 660 else
592 echo "-no-${feature}" 661 echo "-no-${feature}"
593 fi 662 fi
594} 663}
595 664
596# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
597# @DESCRIPTION:
598# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
599# (eutils.eclass), line per line.
600#
601# Example:
602# @CODE
603# pkg_setup() {
604# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
605# ~x11-libs/qt-gui-${PV} qt3support"
606# qt4-build_check_use
607# }
608# @CODE
609
610# Run built_with_use on each flag and print appropriate error messages if any
611# flags are missing
612
613_qt_built_with_use() {
614 local missing opt pkg flag flags
615
616 if [[ ${1} = "--missing" ]]; then
617 missing="${1} ${2}" && shift 2
618 fi
619 if [[ ${1:0:1} = "-" ]]; then
620 opt=${1} && shift
621 fi
622
623 pkg=${1} && shift
624
625 for flag in "${@}"; do
626 flags="${flags} ${flag}"
627 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
628 flags="${flags}*"
629 else
630 [[ ${opt} = "-o" ]] && return 0
631 fi
632 done
633 if [[ "${flags# }" = "${@}" ]]; then
634 return 0
635 fi
636 if [[ ${opt} = "-o" ]]; then
637 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
638 else
639 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
640 fi
641 return 1
642}
643
644# @FUNCTION: qt4-build_check_use
645# @DESCRIPTION:
646# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
647# USE flags listed.
648#
649# If any of the required USE flags are missing, an eerror will be printed for
650# each package with missing USE flags.
651qt4-build_check_use() {
652 local line missing
653 while read line; do
654 [[ -z ${line} ]] && continue
655 if ! _qt_built_with_use ${line}; then
656 missing=true
657 fi
658 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
659 if [[ -n ${missing} ]]; then
660 echo
661 eerror "Flags marked with an * are missing."
662 die "Missing USE flags found"
663 fi
664}
665
666# @FUNCTION: qt_mkspecs_dir 665# @FUNCTION: qt_mkspecs_dir
667# @RETURN: the specs-directory w/o path 666# @RETURN: the specs-directory w/o path
668# @DESCRIPTION: 667# @DESCRIPTION:
669# Allows us to define which mkspecs dir we want to use. 668# Allows us to define which mkspecs dir we want to use.
670qt_mkspecs_dir() { 669qt_mkspecs_dir() {
671 # Allows us to define which mkspecs dir we want to use. 670 # Allows us to define which mkspecs dir we want to use.
672 local spec 671 local spec
673 672
674 case ${CHOST} in 673 case ${CHOST} in
675 *-freebsd*|*-dragonfly*) 674 *-freebsd*|*-dragonfly*)
676 spec="freebsd" ;; 675 spec=freebsd ;;
677 *-openbsd*) 676 *-openbsd*)
678 spec="openbsd" ;; 677 spec=openbsd ;;
679 *-netbsd*) 678 *-netbsd*)
680 spec="netbsd" ;; 679 spec=netbsd ;;
681 *-darwin*) 680 *-darwin*)
681 if use aqua; then
682 # mac with carbon/cocoa
683 spec=macx
684 else
685 # darwin/mac with x11
682 spec="darwin" ;; 686 spec=darwin
687 fi
688 ;;
689 *-solaris*)
690 spec=solaris ;;
683 *-linux-*|*-linux) 691 *-linux-*|*-linux)
684 spec="linux" ;; 692 spec=linux ;;
685 *) 693 *)
686 die "Unknown CHOST, no platform choosen." 694 die "Unknown CHOST, no platform choosen."
687 esac 695 esac
688 696
689 CXX=$(tc-getCXX) 697 CXX=$(tc-getCXX)
690 if [[ ${CXX/g++/} != ${CXX} ]]; then 698 if [[ ${CXX} == *g++* ]]; then
691 spec="${spec}-g++" 699 spec+=-g++
692 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 700 elif [[ ${CXX} == *icpc* ]]; then
693 spec="${spec}-icc" 701 spec+=-icc
694 else 702 else
695 die "Unknown compiler ${CXX}." 703 die "Unknown compiler ${CXX}."
696 fi 704 fi
697 if [[ -n "${LIBDIR/lib}" ]]; then 705 if [[ -n ${LIBDIR/lib} ]]; then
698 spec="${spec}-${LIBDIR/lib}" 706 spec+=-${LIBDIR/lib}
707 fi
708
709 # Add -64 for 64bit profiles
710 if use x64-freebsd ||
711 use amd64-linux ||
712 use x64-macos ||
713 use x64-solaris ||
714 use sparc64-solaris
715 then
716 spec+=-64
699 fi 717 fi
700 718
701 echo "${spec}" 719 echo "${spec}"
702} 720}
703 721
704case ${EAPI:-0} in
705 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;;
706 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 722EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst
707esac

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.64

  ViewVC Help
Powered by ViewVC 1.1.20